
typedef struct _coord
{
   float pt[3];
} coord;

typedef struct _triangleIndex
{
   short index[3];
} triangleIndex;

typedef struct _modelData
{
   int numPoints;
   coord *pointList;
   int numTriangles;
   triangleIndex *triIndex;
} modelData;

typedef struct _modelHeader
{
   int ident;
   int version;
   int skinwidth;
   int skinheight;
   int framesize;
   int numSkins;
   int numXYZ;
   int numST;
   int numTris;
   int numGLcmds;
   int numFrames;
   int offsetSkins;
   int offsetST;
   int offsetTris;
   int offsetFrames;
   int offsetGLcmds;
   int offsetEnd;
} modelHeader;

typedef struct _framePoint
{
   unsigned char v[3];
   unsigned char lightNormalIndex;
} framePoint;

typedef struct _frame
{
   float scale[3];
   float translate[3];
   char name[16];
   framePoint fp[1];
} frame;

typedef struct _mesh
{
   unsigned short meshIndex[3];
   unsigned short stIndex[3];
} mesh;

modelData * loadModel( const char * );

